/*
 * @copyright		Copyright 2006-2010, epages GmbH, All Rights Reserved.
 *
 * @module			de_epages.shop.ui.userCommunityWidget
 */

define( "de_epages/shop/ui/usercommunitywidget", [
	"jquery",
	"ep",
	"de_epages",
	"util/string",
	"$tmpl!./usercommunitywidget",

    "ep/ajax",
	"jquery/i18n",
	"ep/date",
	"ep/ui/tooltip",
	"ep/fn/busy",
	"de_epages/presentation/rss"
], function( $, ep, de_epages, str, tmplUserCommunityWidget ){

	$.widget( "ui.shopUiUserCommunityWidget", {

		_feedData: null,

		options: { //define options of widget formally know as widget properties in dojo
			url: null,
			visibleEntrys: 3,
			entryLength: 50
		},

		_create: function(){
			if(!this.options.url){
				return;
			}
			ep(this.element.parent()).busy();
			//getFeedData
			new de_epages.presentation.Rss(this.options.url, $.proxy(this,'_readFeedData'));
		},

		_readFeedData: function(feedData){
			var self = this,
				o = this.options,
				items = feedData.items.slice(0, o.visibleEntrys),
				urls = [];


            $.each(items, function () {
				this.title = str.shrink(this.title, o.entryLength);
				this.text = str.shrink(this.text, o.entryLength);
				urls.push(this.link);
			});

			// Get links for the dereferred ChangeAction
            ep.ajax({
                dataType: 'json',
                data: {
                    'ViewAction': 'JSONDerefer',
                    'DereferURLs': urls.join(',')
                }
            }).done(function (data) {
                if (data.length !== items.length) {
                    return;
                }

                $.each(items, function (index) {
                    this.link = data[index];
                });

				tmplUserCommunityWidget({'items': items}).appendTo(self.element);
				ep(self.element.parent()).busy('hide');
            });

		},

		destroy: function(){
			this.element.remove();
		}

	});

	return de_epages;

});
